# word_traits< FreeMonoid< A >, std::basic_string< typename A::letter_t > > Struct Template Reference

Meta information about the mixing of FreeMonoid with std::basic_string. More...

List of all members.

## Public Types

typedef A | alphabet_t
| The type of the alphabet.
typedef Element< FreeMonoid< A > , std::basic_string< typename alphabet_t::letter_t > > | word_t
| The type of the word.
typedef word_t::value_t | word_value_t
| The value type of word.
typedef alphabet_traits < typename alphabet_t::set_t, typename alphabet_t::value_t > ::first_projection_t | first_projection_alphabet_t
| The type of the first projection alphabet.
typedef alphabet_traits < typename alphabet_t::set_t, typename alphabet_t::value_t > ::second_projection_t | second_projection_alphabet_t
| The type of the second projection alphabet.
typedef FreeMonoid < first_projection_alphabet_t > | first_monoid_t
| The type of the first projection monoid.
typedef FreeMonoid < second_projection_alphabet_t > | second_monoid_t
| The type of the second projection monoid.
typedef Element < first_monoid_t, std::basic_string< typename first_projection_alphabet_t::letter_t > > | first_projection_t
| The type of the first projection word.
typedef first_projection_t::value_t | first_projection_value_t
| The value type of the first projection word.
typedef Element < second_monoid_t, std::basic_string< typename second_projection_alphabet_t::letter_t > > | second_projection_t
| The type of the second projection word.
typedef second_projection_t::value_t | second_projection_value_t
| The value type of the second projection word.

## Static Public Member Functions

static first_projection_t | first_projection (const first_monoid_t &, const word_t &)
| The first projection word maker.
static second_projection_t | second_projection (const second_monoid_t &, const word_t &)
| The second projection word maker.

## Detailed Description

### template<typename A>
struct vcsn::algebra::word_traits< FreeMonoid< A >, std::basic_string< typename A::letter_t > >

Meta information about the mixing of FreeMonoid with std::basic_string.

Definition at line 85 of file str_words.hh.